﻿/* This file is part of My Nes
 * A Nintendo Entertainment System Emulator.
 *
 * Copyright © Ala I Hadid 2009 - 2012
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
/*Written by $username$*/
using MyNes.Core.Types;
namespace $rootnamespace$
{
    [BoardName("$safeitemname$", 0)]
    class $safeitemname$ : Board
    {
        public $safeitemname$() : base() { }
        public $safeitemname$(byte[] chr, byte[] prg, byte[] trainer, bool isVram) : base(chr, prg, trainer, isVram) { }

        public override void Initialize()
        {
            // Maps prg writes to 0x8000 - 0xFFFF. Maps sram reads and writes to 0x6000 - 0x8000.
            // Then do a hard reset.
            base.Initialize();
            
            // TODO: add your board initialize code like memory mapping. NEVER remove the previous line.
        }
        public override void HardReset()
        {
            // Switch 32KB prg bank at 0x8000
            // Switch 08KB chr bank at 0x0000
            base.HardReset();

            // TODO: add the hard reset code here. Also this called at board initialize so it should be power up code.
        }
        protected override void PokePrg(int address, byte data)
        {
            // TODO: board writes 0x8000 - 0xFFFF are done here.
            // If the board writes on 0x6000 - 0x7FFF, then use overriden PokeSram() method
        }
    }
}
